/*
	MyHelloWindow.cpp
	Dan Parks Sydow
	1997
	
	Based on source code from:
	HelloWindow.cpp
	Copyright 1995 Be Incorporated, All Rights Reserved.
*/

#ifndef _APPLICATION_H
#include <Application.h>
#endif
#ifndef MY_HELLO_WINDOW_H
#include "MyHelloWindow.h"
#endif

BRect  buttonBeepRect(20.0, 70.0, 110.0, 100.0);
const char* buttonBeepName = "Beep";
const char* buttonBeepLabel = "Beep";
// *** NEW
BRect  radioGroupRect(125.0, 50.0, 230.0, 120.0);
BRect  radioBeep1Rect(10.0, 5.0, 90.0, 25.0);
const char* radioBeep1Name = "Beep1Radio";
const char* radioBeep1Label = "One Beep";
BRect  radioBeep2Rect(10.0, 26.0, 90.0, 45.0);
const char* radioBeep2Name = "Beep2Radio";
const char* radioBeep2Label = "Two Beeps";
BRect  radioBeep3Rect(10.0, 46.0, 90.0, 65.0);
const char* radioBeep3Name = "Beep3Radio";
const char* radioBeep3Label = "Three Beeps";
// *** NEW

MyHelloWindow::MyHelloWindow(BRect frame)
    : BWindow(frame, "My Hello", B_TITLED_WINDOW, B_NOT_RESIZABLE)
{
    frame.OffsetTo(B_ORIGIN);
    fMyView = new MyDrawView(frame, "MyDrawView");
    AddChild(fMyView);

	fButtonBeep = new BButton(	buttonBeepRect, 
								buttonBeepName, 
								buttonBeepLabel, 
								new BMessage(BUTTON_BEEP_MSG));
	fMyView->AddChild(fButtonBeep);

// *** NEW
//  create a new, empty BView to hold, or group, the radio buttons
//  See BeBook BRadioButton intro
	BView  *radioGroupView;
	
 	radioGroupView = new BView(radioGroupRect, "RadioView", B_FOLLOW_ALL, B_WILL_DRAW);
    fMyView->AddChild(radioGroupView);

// *** NEW
// create the radio buttons, add them to the radioGroupView that's
// now located in the fMyView view. (show a view hierarchy of this)

	fRadioBeep1 = new BRadioButton(	radioBeep1Rect, 
								radioBeep1Name, 
								radioBeep1Label, 
								new BMessage(RADIO_BEEP_1_MSG));
	radioGroupView->AddChild(fRadioBeep1);

	fRadioBeep2 = new BRadioButton(	radioBeep2Rect, 
								radioBeep2Name, 
								radioBeep2Label, 
								new BMessage(RADIO_BEEP_2_MSG));
	radioGroupView->AddChild(fRadioBeep2);

	fRadioBeep3 = new BRadioButton(	radioBeep3Rect, 
								radioBeep3Name, 
								radioBeep3Label, 
								new BMessage(RADIO_BEEP_3_MSG));
	radioGroupView->AddChild(fRadioBeep3);

	fRadioBeep1->SetValue(B_CONTROL_ON);
	fNumBeeps = 1;

    Show();
}


bool MyHelloWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(TRUE);
}

// *** NEW
void MyHelloWindow::MessageReceived(BMessage* message)
{
    bigtime_t  microseconds = 1000000;  // one second

	switch(message->what)
	{
		case BUTTON_BEEP_MSG:
			int32  i;
			
			for (i=1; i<=fNumBeeps; i++) {
		  	   beep();
		  	   if (i != fNumBeeps)
   			      snooze(microseconds);
   			}
   			break;
	
		case RADIO_BEEP_1_MSG:
		  	fNumBeeps = 1;
		  	break;

		case RADIO_BEEP_2_MSG:
		  	fNumBeeps = 2;
		  	break;

		case RADIO_BEEP_3_MSG:
		  	fNumBeeps = 3;
		  	break;
		  	
		default:
			BWindow::MessageReceived(message);
	}
}
// *** NEW
