/*
	MyHelloWindow.cpp
	Dan Parks Sydow
	1997
	
	Based on source code from:
	HelloWindow.cpp
	Copyright 1995 Be Incorporated, All Rights Reserved.
*/

#ifndef _APPLICATION_H
#include <Application.h>
#endif
#ifndef MY_HELLO_WINDOW_H
#include "MyHelloWindow.h"
#endif

#define   MENU_BAR_HEIGHT   18.0


BRect       buttonBeepRect(15.0, 155.0, 110.0, 185.0);
const char* buttonBeepName = "Beep";
const char* buttonBeepLabel = "Beep";


MyHelloWindow::MyHelloWindow(BRect frame)
    : BWindow(frame, "My Hello", B_TITLED_WINDOW, B_NOT_ZOOMABLE)
{
	frame.Set(130.0, MENU_BAR_HEIGHT + 10.0, 290.0, 190.0);
    fMyView = new MyDrawView(frame, "MyDrawView");
    AddChild(fMyView);

	fButtonBeep = new BButton(buttonBeepRect, buttonBeepName, 
							   buttonBeepLabel, new BMessage(BUTTON_BEEP_MSG));
	AddChild(fButtonBeep);           
    fButtonBeep->MakeDefault(true);

	BMenu		*menu;
	BMenuItem	*menuItem;
	BRect		menuBarRect;

	menuBarRect.Set(0.0, 0.0, 32000.0, MENU_BAR_HEIGHT);
	fMenuBar = new BMenuBar(menuBarRect, "MenuBar");
	AddChild(fMenuBar);
	
	menu = new BMenu("Audio");
	fMenuBar->AddItem(menu);
	menu->AddItem(new BMenuItem("Beep Once", new BMessage(MENU_BEEP_1_MSG)));
	menu->AddItem(menuItem = new BMenuItem("Beep Twice", new BMessage(MENU_BEEP_2_MSG)));

	menu->SetRadioMode(true);
    menuItem->SetMarked(true);
	fNumBeeps = 2;

    Show();
}


bool MyHelloWindow::QuitRequested()
{
    be_app->PostMessage(B_QUIT_REQUESTED);

    return(true);
}


void MyHelloWindow::MessageReceived(BMessage* message)
{

	switch(message->what)
	{
		case BUTTON_BEEP_MSG:
    		bigtime_t  microseconds = 1000000;  // one second
			int32      i;
			
			for (i = 1; i <= fNumBeeps; i++) 
			{
		  	   beep();
		  	   if (i != fNumBeeps)
   			      snooze(microseconds);
   			}
   			
   			// ******* NEW
   			// Clicking the window's button results in a toggling
   			// of the state of the first menu item in the menu.
   			// If the "Beep Once" item was on at the time of the
   			// button click, it will now be off (and vice-versa)
   			BMenuItem  *theItem;
   			
   			theItem = fMenuBar->FindItem("Beep Once");
   			if (theItem->IsEnabled())
   				theItem->SetEnabled(false);
   			else
   				theItem->SetEnabled(true);
			// ******* NEW
 		  	break;

		case MENU_BEEP_1_MSG:
		  	fNumBeeps = 1;
		  	break;

		case MENU_BEEP_2_MSG:
		  	fNumBeeps = 2;
		  	break;
		  	
		default:
			BWindow::MessageReceived(message);
	}
}
