/*
	MyHelloWindow.cpp
	Dan Parks Sydow
	1997
	
	Based on source code from:
	HelloWindow.cpp
	Copyright 1995 Be Incorporated, All Rights Reserved.
*/

#ifndef _APPLICATION_H
#include <Application.h>
#endif
#ifndef MY_HELLO_WINDOW_H
#include "MyHelloWindow.h"
#endif


#define   MENU_BAR_HEIGHT   18.0


BRect       buttonBeepRect(15.0, 155.0, 110.0, 185.0);
const char* buttonBeepName = "Beep";
const char* buttonBeepLabel = "Beep";


MyHelloWindow::MyHelloWindow(BRect frame)
    : BWindow(frame, "My Hello", B_TITLED_WINDOW, B_NOT_ZOOMABLE)
{
	frame.Set(130.0, MENU_BAR_HEIGHT + 10.0, 290.0, 190.0);
    fMyView = new MyDrawView(frame, "MyDrawView");
    AddChild(fMyView);

	fButtonBeep = new BButton(buttonBeepRect, buttonBeepName, 
							   buttonBeepLabel, new BMessage(BUTTON_BEEP_MSG));
	AddChild(fButtonBeep);
    fButtonBeep->MakeDefault(true);

	BMenu		*menu;
	BMenu      	*subMenu;
	BMenuItem	*menuItem;
	BRect		menuBarRect;

 	menuBarRect.Set(0.0, 0.0, 32000.0, MENU_BAR_HEIGHT);
	fMenuBar = new BMenuBar(menuBarRect, "MenuBar");
	AddChild(fMenuBar);  // NOT new
	
	menu = new BMenu("Audio");
	fMenuBar->AddItem(menu);
	menu->AddItem(new BMenuItem("Beep Once", new BMessage(MENU_BEEP_1_MSG)));
	menu->AddItem(menuItem = new BMenuItem("Beep Twice", new BMessage(MENU_BEEP_2_MSG)));

	menu->SetRadioMode(true);
    menuItem->SetMarked(true);
	fNumBeeps = 2;

	menu = new BMenu("Visual");
	fMenuBar->AddItem(menu);  // NOT new
	menu->AddItem(new BMenuItem("Draw Circles", new BMessage(MENU_DRAW_CIRCLES_MSG)));
	menu->AddItem(new BMenuItem("Draw Squares", new BMessage(MENU_DRAW_SQUARES_MSG)));
	// NEW ********** add separator item
   	menu->AddSeparatorItem();
	// NEW ********** create submenu
	subMenu = new BMenu("Number of Shapes");
	menu->AddItem(subMenu);
	subMenu->AddItem(menuItem = new BMenuItem("10", new BMessage(MENU_10_SHAPES_MSG)));
	subMenu->AddItem(new BMenuItem("20", new BMessage(MENU_20_SHAPES_MSG)));
	subMenu->AddItem(new BMenuItem("30", new BMessage(MENU_30_SHAPES_MSG)));
	// NEW ********** create submenu
	

	// NEW ********** make submenu items act in radio mode
	subMenu->SetRadioMode(true);
	// NEW ********** check the 1st item in submenu
    menuItem->SetMarked(true);
	// NEW ********** set the value of the new data member
	fNumShapes = 10;

    Show();
}


bool MyHelloWindow::QuitRequested()
{
    be_app->PostMessage(B_QUIT_REQUESTED);

    return(TRUE);
}


void MyHelloWindow::MessageReceived(BMessage* message)
{

	switch(message->what)
	{
		case BUTTON_BEEP_MSG:
    		bigtime_t  microseconds = 1000000;  // one second
			int32      i;
			
			for (i = 1; i <= fNumBeeps; i++) 
			{
		  	   beep();
		  	   if (i != fNumBeeps)
   			      snooze(microseconds);
   			}
 		  	break;

		case MENU_BEEP_1_MSG:
		  	fNumBeeps = 1;
		  	break;

		case MENU_BEEP_2_MSG:
		  	fNumBeeps = 2;
		  	break;

		case MENU_DRAW_CIRCLES_MSG:
			// NEW ********** new parameter added to this routine:
    		fMyView->SetViewPicture(PICTURE_CIRCLES, fNumShapes);
   			fMyView->Invalidate();
		  	break;

		case MENU_DRAW_SQUARES_MSG:
			// NEW ********** new parameter added to this routine:
    		fMyView->SetViewPicture(PICTURE_SQUARES, fNumShapes);
    		fMyView->Invalidate();
		  	break;

		// NEW ********** these next three case labels are new:
		case MENU_10_SHAPES_MSG:
			fNumShapes = 10;
			break;

		case MENU_20_SHAPES_MSG:
			fNumShapes = 20;
			break;

		case MENU_30_SHAPES_MSG:
			fNumShapes = 30;
			break;
				  	
		default:
			BWindow::MessageReceived(message);
	}
}
