/*
	MyHelloWorld.cpp
	Dan Parks Sydow
	1997
	
	Based on source code from:
	HelloWorld.cpp
	Copyright 1995 Be Incorporated, All Rights Reserved.
*/

#ifndef MY_HELLO_WINDOW_H
#include "MyHelloWindow.h"
#endif
#ifndef MY_HELLO_WORLD_H
#include "MyHelloWorld.h"
#endif

// *************** NEW
#include <stdlib.h>

// *********** NEW
#define    WINDOW_1_LEFT        20.0
#define    WINDOW_1_TOP         30.0
#define    WINDOW_WIDTH        200.0
#define    WINDOW_HEIGHT       100.0
#define    WINDOW_H_OFFSET      30.0
#define    WINDOW_V_OFFSET      30.0


main()
{	
    MyHelloApplication *myApplication;

    myApplication = new MyHelloApplication();
    myApplication->Run();
	
    delete(myApplication);
    return(0);
}

MyHelloApplication::MyHelloApplication()
		  		  : BApplication("application/x-dps-twoapps")
{
   float          left   = WINDOW_1_LEFT;
   float          right  = left + WINDOW_WIDTH;
   float          top    = WINDOW_1_TOP;
   float          bottom = top + WINDOW_HEIGHT;
   BRect          aRect;
   MyHelloWindow  *theWindow;

   aRect.Set(left, top, right, bottom);
   theWindow = new MyHelloWindow(aRect);
}
	

// ******* NEW
void MyHelloApplication::ArgvReceived(int32 argc, char **argv)
{
	uint32 userNumWindows = atoi(argv[1]);

    BRect          aRect;
	float          left = WINDOW_1_LEFT + WINDOW_H_OFFSET;
	float          right = left + WINDOW_WIDTH;
	float          top = WINDOW_1_TOP + WINDOW_V_OFFSET;
	float          bottom = top + WINDOW_HEIGHT;
    MyHelloWindow  *theWindow;
	uint32         i;

if (userNumWindows > 5) {
   bool        beepOnce = true;
   const char  *alertString = "Maximum windows open";
   BMessage    *maxWindowsMsg = new BMessage(WINDOW_MAX_MSG);

   userNumWindows = 5;
   maxWindowsMsg->AddBool("Beep", beepOnce);
   maxWindowsMsg->AddString("AlertString", alertString);
   be_app->PostMessage(maxWindowsMsg, be_app);
}

for (i = 2; i <= userNumWindows; i++) {
    aRect.Set(left, top, right, bottom);
    theWindow = new MyHelloWindow(aRect);
    left   += WINDOW_H_OFFSET;
    right  += WINDOW_H_OFFSET;
    top    += WINDOW_V_OFFSET;  
	bottom += WINDOW_V_OFFSET;
}

}
// *********** NEW


void MyHelloApplication::MessageReceived(BMessage* message)
{
	switch (message->what) {
	
		case WINDOW_MAX_MSG:
   			bool        beepOnce;
   			const char  *alertString;
    		BAlert      *alert;
    		long        result;

		    beepOnce = message->FindBool("Beep");
		    alertString = message->FindString("AlertString");

     		if (beepOnce)
     		   beep();
     		   
     		alert = new BAlert("MaxWindowAlert", alertString, "OK");
    		result = alert->Go();
						
			break;
	}
}